#ifndef __VPCALC_MEM_H
#define __VPCALC_MEM_H

#ifndef PERM_READ
#define PERM_READ	0x0001
#define PERM_WRITE	0x0002
#define PERM_EXEC	0x0004
#endif

typedef void *mem_o;

mem_o mem_new(const char *libname);
void mem_del(mem_o mem);

size_t mem_size(mem_o mem);
size_t mem_bus_size(mem_o mem);

void mem_putimage(mem_o mem, void *data);
void mem_getimage(mem_o mem, void *data);

uint mem_fetch(mem_o mem, uint addr);
uint mem_read(mem_o mem, uint addr);
void mem_write(mem_o mem, uint addr, uint data);

uint8 mem_fetch_byte(mem_o mem, uint addr);
uint8 mem_read_byte(mem_o mem, uint addr);
void mem_write_byte(mem_o mem, uint addr, uint8 data);

void mem_remap(mem_o memory, uint page, uint addr, uint perm);
int mem_raw(mem_o memory, void **rd_ptr, void **wr_ptr, void **ex_ptr);

#endif
